import java.awt.*;
import java.awt.event.*;

public class CCurve extends Frame
{
   public static final int SLEEP_TIME = 1000;

   public CCurve()
   {
      super( "Drawing C Curve" );
      setSize( 500, 500 );
      setVisible(true);
   }


  public void drawCCurve(Graphics g, int n, int x1, int y1, int x2, int y2)
  {
    if (n == 1)
       g.drawLine(x1, y1, x2, y2);
    else
    {
      int xMid = (x1+x2)/2;
      int yMid = (y1+y2)/2;
      int xDiff = x1 - xMid;
      int yDiff = y1 - yMid;
      int x3 = xMid + yDiff;
      int y3 = yMid - xDiff;
      drawCCurve(g, n-1, x1, y1, x3, y3);
      drawCCurve(g, n-1, x3, y3, x2, y2);
    }
  }//drawCCurve


  public void paint(Graphics g)
  {
     for (int n = 1; n <= 16; n++) // draw 16 steps of the C curve
     {
       g.setColor(Color.WHITE);
       g.fillRect(0,0,500,500);  // erase the previous drawing
       g.setColor(Color.BLACK);
       drawCCurve(g, n, 250, 150, 250, 350);
       // increase the following amount of delay to slow down the drawing
       try{ Thread.sleep(SLEEP_TIME); } catch (InterruptedException e){}
     }
  }//paint


   // The main method creates an instance of this class
   // thereby "running" this program.
   public static void main( String args[] )
   {
      CCurve app = new CCurve();
   }//main

}//CCurve