/*

*/
import java.awt.*;

public class FractalSquares2 extends Frame
{
   public static final int SLEEP_TIME = 100;

   public FractalSquares2()
   {
      super( "Drawing Recursive Fractal" );
      setSize( 500, 500 );
      setVisible(true);
      addWindowListener( new java.awt.event.WindowAdapter()
         {  public void windowClosing(java.awt.event.WindowEvent e)
            { System.exit(0); }
         }
      );
   }

   public void recursiveDrawing(int n, Graphics g, Square sq)
   {
      if (n == 0)
      {
         g.setColor(Color.red);
         g.fillPolygon( sq.xPolygonValues(), sq.yPolygonValues(), 4 );
         try{ Thread.sleep(SLEEP_TIME); } catch (InterruptedException e){}
      }
      else
      {
         recursiveDrawing(n-1, g, sq.square1());
         recursiveDrawing(n-1, g, sq.square4());
         recursiveDrawing(n-1, g, sq.square5());
         recursiveDrawing(n-1, g, sq.square8());
         recursiveDrawing(n-1, g, sq.square9());
         recursiveDrawing(n-1, g, sq.square3());
      }
   }

   public void paint( Graphics g )
   {
      recursiveDrawing( 4, g, new Square(0, 0, 500, 500) );
   }


   // The main method creates an instance of this class
   // thereby "running" this program.
   public static void main( String args[] )
   {
      FractalSquares2 app = new FractalSquares2();
   }//main

}//FractalSquares2


class Square
{
   public int x1, x2, y1, y2;

   public Square(int x1, int y1, int x2, int y2)
   {
      this.x1 = x1;
      this.y1 = y1;
      this.x2 = x2;
      this.y2 = y2;
   }

   public Square square1()
   {
      return new Square(x1, y1, (2*x1+x2)/3, (2*y1+y2)/3);
   }

   public Square square2()
   {
      return new Square((2*x1+x2)/3, y1, (x1+2*x2)/3, (2*y1+y2)/3);
   }

   public Square square3()
   {
      return new Square((x1+2*x2)/3, y1, x2, (2*y1+y2)/3);
   }

   public Square square4()
   {
      return new Square(x1, (2*y1+y2)/3, (2*x1+x2)/3, (y1+2*y2)/3);
   }

   public Square square5()
   {
      return new Square((2*x1+x2)/3, (2*y1+y2)/3, (x1+2*x2)/3, (y1+2*y2)/3);
   }

   public Square square6()
   {
      return new Square((x1+2*x2)/3, (2*y1+y2)/3, x2, (y1+2*y2)/3);
   }

   public Square square7()
   {
      return new Square(x1, (y1+2*y2)/3, (2*x1+x2)/3, y2);
   }

   public Square square8()
   {
      return new Square((2*x1+x2)/3, (y1+2*y2)/3, (x1+2*x2)/3, y2);
   }

   public Square square9()
   {
      return new Square((x1+2*x2)/3, (y1+2*y2)/3, x2, y2);
   }

   public int[] xPolygonValues()
   {
      return ( new int[]{x1, x2, x2, x1} );
   }

   public int[] yPolygonValues()
   {
      return ( new int[]{y1, y1, y2, y2} );
   }

}