/*

*/
import java.awt.*;

public class RecursiveSquares2a extends Frame
{
   public static final int SLEEP_TIME = 200;

   public RecursiveSquares2a()
   {
      super( "Drawing Recursive Squares" );
      setSize( 500, 500 );
      setVisible(true);
   }

   public void recursiveDrawing(int n, Graphics g, Square sq)
   {
      if (n == 0) return;

      g.setColor(Color.red);
      g.fillPolygon( sq.upperRight().xPolygonValues(), sq.upperRight().yPolygonValues(), 4 );
      try{ Thread.sleep(SLEEP_TIME); } catch (InterruptedException e){}

      g.setColor(Color.green);
      g.fillPolygon( sq.lowerLeft().xPolygonValues(), sq.lowerLeft().yPolygonValues(), 4 );
      try{ Thread.sleep(SLEEP_TIME); } catch (InterruptedException e){}

      recursiveDrawing(n-1, g, sq.upperLeft());

      recursiveDrawing(n-1, g, sq.lowerRight());
   }

   public void paint( Graphics g )
   {
      recursiveDrawing( 5, g, new Square(0, 0, 500, 500) );
   }


   // The main method creates an instance of this class
   // thereby "running" this program.
   public static void main( String args[] )
   {
      RecursiveSquares2a app = new RecursiveSquares2a();
   }//main

}//RecursiveSquares2a


class Square
{
   public int x1, x2, y1, y2;

   public Square(int x1, int y1, int x2, int y2)
   {
      this.x1 = x1;
      this.y1 = y1;
      this.x2 = x2;
      this.y2 = y2;
   }

   public Square upperLeft()
   {
      return new Square(x1, y1, (x1+x2)/2, (y1+y2)/2);
   }

   public Square upperRight()
   {
      return new Square((x1+x2)/2, y1, x2, (y1+y2)/2);
   }

   public Square lowerLeft()
   {
      return new Square(x1, (y1+y2)/2, (x1+x2)/2, y2);
   }

   public Square lowerRight()
   {
      return new Square((x1+x2)/2, (y1+y2)/2, x2, y2);
   }

   public int[] xPolygonValues()
   {
      return ( new int[]{x1, x2, x2, x1} );
   }

   public int[] yPolygonValues()
   {
      return ( new int[]{y1, y1, y2, y2} );
   }

}