/*

*/
import java.awt.*;

public class RecursiveTriangleSleepTrace extends Frame
{
   public static final int SLEEP_TIME = 200;
   public static final boolean IN = true;
   public static final boolean OUT = false;

   public RecursiveTriangleSleepTrace()
   {
      super( "Drawing Triangles" );
      setSize( 500, 500 );
      setVisible(true);
   }

   public void recursiveDrawing(int n, Graphics g, int x1, int y1, int x2, int y2, int x3, int y3)
   {
      trace("recursiveDrawing", IN, n, x1, y1, x2, y2, x3, y3);

      if (n == 0)
      {
         g.setColor(Color.red);
         int[] xValues = {x1, x2, x3};
         int[] yValues = {y1, y2, y3};
         g.fillPolygon( xValues, yValues, 3 );
         try{ Thread.sleep(SLEEP_TIME); } catch (InterruptedException e){}
      }
      else
      {
         recursiveDrawing(n-1, g, x1, y1, (x1+x2)/2, (y1+y2)/2, (x1+x3)/2, (y1+y3)/2);

         recursiveDrawing(n-1, g, (x1+x2)/2, (y1+y2)/2, x2, y2, (x2+x3)/2, (y2+y3)/2);

         recursiveDrawing(n-1, g, (x1+x3)/2, (y1+y3)/2, (x2+x3)/2, (y2+y3)/2, x3, y3);
      }
      trace("recursiveDrawing", OUT, n, x1, y1, x2, y2, x3, y3);
   }

   public static void trace(String name, boolean in, int n, int x1, int y1,
                                                    int x2, int y2,
                                                    int x3, int y3)
   {
      int maxIndentation = 10;
      String arrow = "";

      for (int i = 0; i < maxIndentation-n; i++)
         arrow += "-";

      if (in)
         arrow = arrow + ">";
      else
         arrow = "<" + arrow;

      System.out.println( arrow + name +"(" + n + " "
                                            + x1 + " "
                                            + y1 + " "
                                            + (x1+x2)/2 + " "
                                            + (y1+y2)/2 + " "
                                            + (x1+x3)/2 + " "
                                            + (y1+y3)/2 + ")" );
   }

   public void paint( Graphics g )
   {
      recursiveDrawing(6, g, 250, 0, 500, 500, 0, 500);
   }


   // The main method creates an instance of this class
   // thereby "running" this program.
   public static void main( String args[] )
   {
      RecursiveTriangleSleepTrace app = new RecursiveTriangleSleepTrace();
   }//main

}//RecursiveTriangleSleepTrace
